unit Main;

interface

(* Embracer Main Module (Delphi Developer 2.01) - 02/01/97
   Copyright (c) 1997 by William E. Sorensen.
   May be distributed for non-commercial purposes.
*)

{ Eventually, may want to add Bounder and scaling. }

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, Spin, ComCtrls, DotEdit, Buttons, Undo;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MMFile: TMenuItem;
    MMExit: TMenuItem;
    N1: TMenuItem;
    MMPrintSetup: TMenuItem;
    MMPrint: TMenuItem;
    N2: TMenuItem;
    MMNew: TMenuItem;
    PCMain: TPageControl;
    TSGeneral: TTabSheet;
    LName: TLabel;
    LPlayer: TLabel;
    LNature: TLabel;
    LConcept: TLabel;
    LClan: TLabel;
    LDemeanor: TLabel;
    CBNature: TComboBox;
    EPlayer: TEdit;
    EName: TEdit;
    CBConcept: TComboBox;
    CBClan: TComboBox;
    CBDemeanor: TComboBox;
    TSAttributes: TTabSheet;
    MMTools: TMenuItem;
    MMDicePool: TMenuItem;
    TSAbilities: TTabSheet;
    LBAttribPri: TListBox;
    BBAttribPriUp: TBitBtn;
    BBAttribPriDn: TBitBtn;
    LBAttribPST: TListBox;
    GBPhysical: TGroupBox;
    GBSocial: TGroupBox;
    GBMental: TGroupBox;
    DEStamina: TDotEdit;
    LStamina: TLabel;
    DEDexterity: TDotEdit;
    LDexterity: TLabel;
    LStrength: TLabel;
    DEStrength: TDotEdit;
    LCharisma: TLabel;
    LManipulation: TLabel;
    LAppearance: TLabel;
    DEAppearance: TDotEdit;
    DEManipulation: TDotEdit;
    DECharisma: TDotEdit;
    DEWits: TDotEdit;
    LWits: TLabel;
    LIntelligence: TLabel;
    DEIntelligence: TDotEdit;
    DEPerception: TDotEdit;
    LPerception: TLabel;
    PhysicalPointsPanel: TPanel;
    SocialPointsPanel: TPanel;
    MentalPointsPanel: TPanel;
    LBAbilPST: TListBox;
    LBAbilPri: TListBox;
    BBAbilPriUp: TBitBtn;
    BBAbilPriDn: TBitBtn;
    GBTalents: TGroupBox;
    LAthletics: TLabel;
    LAlertness: TLabel;
    LActing: TLabel;
    DEAthletics: TDotEdit;
    DEAlertness: TDotEdit;
    DEActing: TDotEdit;
    TalentsPointsPanel: TPanel;
    GBSkills: TGroupBox;
    LAnimalKen: TLabel;
    LDrive: TLabel;
    LEtiquette: TLabel;
    DEEtiquette: TDotEdit;
    DEDrive: TDotEdit;
    DEAnimalKen: TDotEdit;
    SkillsPointsPanel: TPanel;
    GBKnowledge: TGroupBox;
    LFinance: TLabel;
    LComputer: TLabel;
    LBureaucracy: TLabel;
    DEFinance: TDotEdit;
    DEComputer: TDotEdit;
    DEBureaucracy: TDotEdit;
    KnowledgePointsPanel: TPanel;
    DEBrawl: TDotEdit;
    DEDodge: TDotEdit;
    DEEmpathy: TDotEdit;
    DEIntimidation: TDotEdit;
    MMPage: TMenuItem;
    MMClearPage: TMenuItem;
    N5: TMenuItem;
    MMUndo: TMenuItem;
    DELeadership: TDotEdit;
    DEStreetwise: TDotEdit;
    DESubterfuge: TDotEdit;
    LBrawl: TLabel;
    LDodge: TLabel;
    LEmpathy: TLabel;
    LIntimidation: TLabel;
    LLeadership: TLabel;
    LStreetwise: TLabel;
    LSubterfuge: TLabel;
    DEFirearms: TDotEdit;
    DEMelee: TDotEdit;
    DEMusic: TDotEdit;
    DERepair: TDotEdit;
    DESecurity: TDotEdit;
    DEStealth: TDotEdit;
    DESurvival: TDotEdit;
    LFirearms: TLabel;
    LMelee: TLabel;
    LMusic: TLabel;
    LRepair: TLabel;
    LSecurity: TLabel;
    LStealth: TLabel;
    LSurvival: TLabel;
    DEInvestigation: TDotEdit;
    DELaw: TDotEdit;
    DELinguistics: TDotEdit;
    DEMedicine: TDotEdit;
    DEOccult: TDotEdit;
    DEPolitics: TDotEdit;
    DEScience: TDotEdit;
    LInvestigation: TLabel;
    LLaw: TLabel;
    LLinguistics: TLabel;
    LMedicine: TLabel;
    LOccult: TLabel;
    LPolitics: TLabel;
    LScience: TLabel;
    TSAdvantages: TTabSheet;
    GBDisciplines: TGroupBox;
    LCelerity: TLabel;
    LAuspex: TLabel;
    LAnimalism: TLabel;
    LDominate: TLabel;
    LFortitude: TLabel;
    LObfuscate: TLabel;
    LPotence: TLabel;
    LPresence: TLabel;
    LProtean: TLabel;
    LThaumaturgy: TLabel;
    DECelerity: TDotEdit;
    DEAuspex: TDotEdit;
    DEAnimalism: TDotEdit;
    DisciplinesPointsPanel: TPanel;
    DEDominate: TDotEdit;
    DEFortitude: TDotEdit;
    DEObfuscate: TDotEdit;
    DEPotence: TDotEdit;
    DEPresence: TDotEdit;
    DEProtean: TDotEdit;
    DEThaumaturgy: TDotEdit;
    GBBackgrounds: TGroupBox;
    LAllies: TLabel;
    LContacts: TLabel;
    LFame: TLabel;
    LGeneration: TLabel;
    LHerd: TLabel;
    LInfluence: TLabel;
    LMentor: TLabel;
    LResources: TLabel;
    LRetainers: TLabel;
    LStatus: TLabel;
    DEFame: TDotEdit;
    DEContacts: TDotEdit;
    DEAllies: TDotEdit;
    BackgroundsPointsPanel: TPanel;
    DEGeneration: TDotEdit;
    DEHerd: TDotEdit;
    DEInfluence: TDotEdit;
    DEMentor: TDotEdit;
    DEResources: TDotEdit;
    DERetainers: TDotEdit;
    DEStatus: TDotEdit;
    GBVirtues: TGroupBox;
    LCourage: TLabel;
    LSelfControl: TLabel;
    LConscience: TLabel;
    DECourage: TDotEdit;
    DESelfControl: TDotEdit;
    DEConscience: TDotEdit;
    VirtuesPointsPanel: TPanel;
    LUgly: TLabel;
    TSFinal: TTabSheet;
    GBFinishingTouches: TGroupBox;
    LBloodPool: TLabel;
    LWillpower: TLabel;
    LHumanity: TLabel;
    DEBloodPool: TDotEdit;
    DEWillpower: TDotEdit;
    DEHumanity: TDotEdit;
    FreebiePointsPanel: TPanel;
    LFreebie: TLabel;
    BEnableFreebies: TButton;
    FreebieBevel: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    MMHelp: TMenuItem;
    MMAbout: TMenuItem;
    PrinterSetupDialog: TPrinterSetupDialog;
    PrintDialog: TPrintDialog;
    procedure FormCreate(Sender: TObject);
    procedure MMExitClick(Sender: TObject);
    procedure MMDicePoolClick(Sender: TObject);
    procedure BBAttribPriUpClick(Sender: TObject);
    procedure BBAttribPriDnClick(Sender: TObject);
    procedure DotEditClick(Sender: TObject);
    procedure DotEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MMNewClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BBAbilPriUpClick(Sender: TObject);
    procedure BBAbilPriDnClick(Sender: TObject);
    procedure MMUndoClick(Sender: TObject);
    procedure MMClearPageClick(Sender: TObject);
    procedure CBClanChange(Sender: TObject);
    procedure PCMainChange(Sender: TObject);
    procedure BEnableFreebiesClick(Sender: TObject);
    procedure PCMainChanging(Sender: TObject; var AllowChange: Boolean);
    procedure MMPrintClick(Sender: TObject);
    procedure MMPrintSetupClick(Sender: TObject);
    procedure MMAboutClick(Sender: TObject);
  private
    PreviousClan : String;
    procedure UpdateAttribPointsPanels;
    procedure UpdateAbilPointsPanels;
    procedure InitializeAdvantPointsPanels;
    procedure CheckIfReadyForFreebies;
    procedure RollBloodPool;
    procedure DisableStuffAfterPointsAssigned;
    procedure SetEnabledOnAllDisciplines(NewSetting: Boolean);
    procedure ClearPage(TSPage: TTabSheet; ClearingAll: Boolean);
    procedure ClearAllPages;
    procedure PrintCharacter(RealHumanity: Byte; RealWillpower: Byte);
  public
    FreebiePointsUndoStack : TUndoStack;
  end;

const
  PROGRAM_VERSION = '1.0a';

  { Initial Point Arrays (Primary, Secondary, Tertiary) }
  A_INIT_ATTRIB_POINTS : array[0..2] of Byte = ( 7, 5, 3);
  A_INIT_ABIL_POINTS   : array[0..2] of Byte = (13, 9, 5);

  { Initial Ability score restriction }
  INIT_ABIL_MAX = 3;

  { Initial Advantages Points }
  INIT_DISCIPLINES_POINTS = 3;
  INIT_BACKGROUNDS_POINTS = 5;
  INIT_VIRTUES_POINTS     = 7;

  FREEBIE_POINTS = 15;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  Printers, Dice, DicePool, PtSrc, About;

procedure TMainForm.FormCreate(Sender: TObject);
var
  i : Integer;
begin
  Randomize;

  PreviousClan := '';

  with PCMain do
    for i := 0 to (PageCount - 1) do
      Pages[i].Tag := Longint(TUndoStack.Create);

  FreebiePointsUndoStack := TUndoStack.Create;

  with CBConcept.Items do
    begin
      Clear;
      Add('Criminal');
      Add('Dilettante');
      Add('Drifter');
      Add('Entertainer');
      Add('Investigator');
      Add('Kid');
      Add('Outsider');
      Add('Politician');
      Add('Professional');
      Add('Punk');
      Add('Reporter');
      Add('Soldier');
      Add('Worker');
    end;

  with CBClan.Items do
    begin
      Clear;
      Add('Brujah');
      Add('Gangrel');
      Add('Malkavian');
      Add('Nosferatu');
      Add('Toreador');
      Add('Tremere');
      Add('Ventrue');
      Add('Caitiff');
    end;

  with CBNature.Items do
    begin
      Clear;
      Add('Architect');
      Add('Bon Vivant');
      Add('Bravo');
      Add('Caregiver');
      Add('Child');
      Add('Conformist');
      Add('Conniver');
      Add('Curmudgeon');
      Add('Deviant');
      Add('Director');
      Add('Fanatic');
      Add('Gallant');
      Add('Jester');
      Add('Judge');
      Add('Loner');
      Add('Martyr');
      Add('Rebel');
      Add('Survivor');
      Add('Traditionalist');
      Add('Visionary');
    end;

  with CBDemeanor.Items do
    begin
      Clear;
      Assign(CBNature.Items);
    end;

  with LBAttribPST do
    begin
      with Items do
        begin
          Clear;
          Add('   Primary (' + IntToStr(A_INIT_ATTRIB_POINTS[0]) + '):');
          Add(' Secondary (' + IntToStr(A_INIT_ATTRIB_POINTS[1]) + '):');
          Add('  Tertiary (' + IntToStr(A_INIT_ATTRIB_POINTS[2]) + '):');
        end;
      ItemIndex := (-1);
    end;

  with LBAbilPST do
    begin
      with Items do
        begin
          Clear;
          Add('   Primary (' + IntToStr(A_INIT_ABIL_POINTS[0]) + '):');
          Add(' Secondary (' + IntToStr(A_INIT_ABIL_POINTS[1]) + '):');
          Add('  Tertiary (' + IntToStr(A_INIT_ABIL_POINTS[2]) + '):');
        end;
      ItemIndex := (-1);
    end;

  ClearAllPages;  { this must be last - UndoStacks must already be created }
end;

procedure TMainForm.MMExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.MMDicePoolClick(Sender: TObject);
begin
  DicePoolForm.Show;
end;

procedure TMainForm.BBAttribPriUpClick(Sender: TObject);
var
  NewIndex : Integer;
begin
  with LBAttribPri do
    if ItemIndex > 0 then
      begin
        NewIndex := ItemIndex - 1;
        Items.Move(ItemIndex,NewIndex);  { resets ItemIndex to -1 }
        ItemIndex := NewIndex;

        UpdateAttribPointsPanels;
      end;
end;

procedure TMainForm.BBAttribPriDnClick(Sender: TObject);
var
  NewIndex : Integer;
begin
  with LBAttribPri do
    if (ItemIndex >= 0) and (ItemIndex < (Items.Count - 1)) then
      begin
        NewIndex := ItemIndex + 1;
        Items.Move(ItemIndex,NewIndex);  { resets ItemIndex to -1 }
        ItemIndex := NewIndex;

        UpdateAttribPointsPanels;
      end;
end;

procedure TMainForm.DotEditClick(Sender: TObject);
var
  PointSource : TPointSource;
begin
  if Sender is TDotEdit then
    begin
      PointSource := TPointSource.Create;

      with PointSource do
        try
          DestDotEdit := TDotEdit(Sender);

          ApplyPointToDot;

          if FreebiePointsPanel.Enabled then
            FreebiePointsUndoStack.Push(PointSource)
          else
            begin
              DisableStuffAfterPointsAssigned;

              { we know there's an active page }
              TUndoStack(PCMain.ActivePage.Tag).Push(PointSource);
            end;
        finally
          Free;
          TDotEdit(Sender).SelectAll;
          CheckIfReadyForFreebies;
        end;
    end;
end;

procedure TMainForm.DotEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = ' ' then
    DotEditClick(Sender);
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := (MessageDlg('Really quit (character will be lost)?',
                          mtConfirmation,mbYesNoCancel,0) = mrYes);
end;

procedure TMainForm.MMNewClick(Sender: TObject);
begin
  if MessageDlg('Really clear all pages (character will be lost)?',
                mtConfirmation,mbYesNoCancel,0) = mrYes then
    ClearAllPages;
end;

procedure TMainForm.UpdateAttribPointsPanels;
var
  i : Integer;
begin
  with LBAttribPri.Items do
    for i := 0 to (Count - 1) do
      with Self.FindComponent(Strings[i] + 'PointsPanel') as TPanel do
        Caption := IntToStr(A_INIT_ATTRIB_POINTS[i]);
end;

procedure TMainForm.UpdateAbilPointsPanels;
var
  i : Integer;
begin
  with LBAbilPri.Items do
    for i := 0 to (Count - 1) do
      with Self.FindComponent(Strings[i] + 'PointsPanel') as TPanel do
        Caption := IntToStr(A_INIT_ABIL_POINTS[i]);
end;

procedure TMainForm.InitializeAdvantPointsPanels;
begin
  DisciplinesPointsPanel.Caption := IntToStr(INIT_DISCIPLINES_POINTS);
  BackgroundsPointsPanel.Caption := IntToStr(INIT_BACKGROUNDS_POINTS);
  VirtuesPointsPanel.Caption     := IntToStr(INIT_VIRTUES_POINTS);
end;

procedure TMainForm.CheckIfReadyForFreebies;
begin
  BEnableFreebies.Enabled :=
    (not FreebiePointsPanel.Enabled) and
    (StrToIntDef(PhysicalPointsPanel.Caption,0) = 0) and
    (StrToIntDef(SocialPointsPanel.Caption,0) = 0) and
    (StrToIntDef(MentalPointsPanel.Caption,0) = 0) and
    (StrToIntDef(TalentsPointsPanel.Caption,0) = 0) and
    (StrToIntDef(SkillsPointsPanel.Caption,0) = 0) and
    (StrToIntDef(KnowledgePointsPanel.Caption,0) = 0) and
    (StrToIntDef(DisciplinesPointsPanel.Caption,0) = 0) and
    (StrToIntDef(BackgroundsPointsPanel.Caption,0) = 0) and
    (StrToIntDef(VirtuesPointsPanel.Caption,0) = 0);
end;

procedure TMainForm.RollBloodPool;
var
  d10 : TDie;
begin
  d10 := TDie.Create(10);

  with d10 do
    try
      DEBloodPool.Dots := Roll;
    finally
      Free;
    end;
end;

procedure TMainForm.DisableStuffAfterPointsAssigned;
begin
  CBClan.Enabled := False;

  if Assigned(PCMain.ActivePage) then
    begin
      with PCMain.ActivePage do
        begin
          if Name = 'TSAttributes' then
            begin
              LBAttribPri.Enabled   := False;
              LBAttribPri.ItemIndex := (-1);
              BBAttribPriUp.Enabled := False;
              BBAttribPriDn.Enabled := False;
            end
          else if Name = 'TSAbilities' then
            begin
              LBAbilPri.Enabled   := False;
              LBAbilPri.ItemIndex := (-1);
              BBAbilPriUp.Enabled := False;
              BBAbilPriDn.Enabled := False;
            end;
          { on Advantages, just want to disable Clan }
          { doesn't hurt to disable Clan on Final }
        end;
    end;
end;

procedure TMainForm.SetEnabledOnAllDisciplines(NewSetting: Boolean);
var
  i : Integer;
begin
  with GBDisciplines do
    for i := 0 to (ControlCount - 1) do
      if Controls[i] is TDotEdit then
        TDotEdit(Controls[i]).Enabled := NewSetting;
end;

procedure TMainForm.ClearPage(TSPage: TTabSheet; ClearingAll: Boolean);
var
  i : Integer;
  j : Integer;
begin
  TUndoStack(TSPage.Tag).Clear;
  { FreebiePointUndoStack is cleared in ClearAllPages }

  if TSPage.Name = 'TSGeneral' then
    begin
      EName.Text           := '';
      EPlayer.Text         := '';
      CBConcept.ItemIndex  := 0;
      CBNature.ItemIndex   := 0;
      CBDemeanor.ItemIndex := 0;

      if ClearingAll then
        CBClan.Enabled := True;

      if CBClan.Enabled then
        begin
          CBClan.ItemIndex := 0;
          CBClanChange(CBClan);
        end
      else
        MessageDlg('Only File | New can reset Clan once points have been ' +
                   'assigned.',mtInformation,[mbOk],0);

      if not ClearingAll then
        EName.SetFocus;
    end
  else if TSPage.Name = 'TSAttributes' then
    begin
      with LBAttribPri do
        begin
          with Items do
            begin
              Clear;
              Add('Physical');
              Add('Social');
              Add('Mental');
            end;
          ItemIndex := 0;
          Enabled   := True;
        end;

      BBAttribPriUp.Enabled := True;
      BBAttribPriDn.Enabled := True;

      UpdateAttribPointsPanels;

      with TSAttributes do
        for i := 0 to (ControlCount - 1) do
          if Controls[i] is TGroupBox then
            with TGroupBox(Controls[i]) do
              for j := 0 to (ControlCount - 1) do
                if Controls[j] is TDotEdit then
                  TDotEdit(Controls[j]).Dots := 1;

      if not ClearingAll then
        LBAttribPri.SetFocus;
    end
  else if TSPage.Name = 'TSAbilities' then
    begin
      with LBAbilPri do
        begin
          with Items do
            begin
              Clear;
              Add('Talents');
              Add('Skills');
              Add('Knowledge');
            end;
          ItemIndex := 0;
          Enabled   := True;
        end;

      BBAbilPriUp.Enabled := True;
      BBAbilPriDn.Enabled := True;

      UpdateAbilPointsPanels;

      with TSAbilities do
        for i := 0 to (ControlCount - 1) do
          if Controls[i] is TGroupBox then
            with TGroupBox(Controls[i]) do
              for j := 0 to (ControlCount - 1) do
                if Controls[j] is TDotEdit then
                  TDotEdit(Controls[j]).Dots := 0;

      if not ClearingAll then
        LBAbilPri.SetFocus;
    end
  else if TSPage.Name = 'TSAdvantages' then
    begin
      InitializeAdvantPointsPanels;

      with TSAdvantages do
        for i := 0 to (ControlCount - 1) do
          if Controls[i] is TGroupBox then
            with TGroupBox(Controls[i]) do
              for j := 0 to (ControlCount - 1) do
                if Controls[j] is TDotEdit then
                  if Name = 'GBVirtues' then
                    TDotEdit(Controls[j]).Dots := 1
                  else
                    TDotEdit(Controls[j]).Dots := 0;

      if not ClearingAll then
        begin
          { Select the first Discipline that's enabled.  Tricky, huh? }
          PCMain.SetFocus;
          PostMessage(Handle,WM_NEXTDLGCTL,0,0);  { "tab" to next control }
        end;
    end
  else if (TSPage.Name = 'TSFinal') and ClearingAll then
    begin
      { The ClearingAll check is redundant - otherwise, we wouldn't be here. }

      DEHumanity.Dots  := 0;
      DEWillpower.Dots := 0;

      DEHumanity.Enabled  := False;
      DEWillpower.Enabled := False;

      RollBloodPool;  { DEBloodPool is always disabled }

      FreebiePointsPanel.Caption := IntToStr(FREEBIE_POINTS);
      FreebiePointsPanel.Enabled := False;

      { CheckIfReadyForFreebies will handle BEnableFreebies.Enabled }
    end;

  CheckIfReadyForFreebies;
end;

procedure TMainForm.ClearAllPages;
var
  i : Integer;
begin
  FreebiePointsUndoStack.Clear;

  { We want to be sure that CBClanChange will reset enabled Disciplines. }
  PreviousClan := '';

  with PCMain do
    begin
      for i := 0 to (PageCount - 1) do
        ClearPage(Pages[i],True);

      ActivePage := TSGeneral;
      { This will NOT call PCMainChanging, but that's as it should be. }
    end;

  ActiveControl := EName;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  i : Integer;
begin
  FreebiePointsUndoStack.Free;

  with PCMain do
    for i := (PageCount - 1) downto 0 do
      TUndoStack(Pages[i].Tag).Free;
end;

procedure TMainForm.BBAbilPriUpClick(Sender: TObject);
var
  NewIndex : Integer;
begin
  with LBAbilPri do
    if ItemIndex > 0 then
      begin
        NewIndex := ItemIndex - 1;
        Items.Move(ItemIndex,NewIndex);  { resets ItemIndex to -1 }
        ItemIndex := NewIndex;

        UpdateAbilPointsPanels;
      end;
end;

procedure TMainForm.BBAbilPriDnClick(Sender: TObject);
var
  NewIndex : Integer;
begin
  with LBAbilPri do
    if (ItemIndex >= 0) and (ItemIndex < (Items.Count - 1)) then
      begin
        NewIndex := ItemIndex + 1;
        Items.Move(ItemIndex,NewIndex);  { resets ItemIndex to -1 }
        ItemIndex := NewIndex;

        UpdateAbilPointsPanels;
      end;
end;

procedure TMainForm.MMUndoClick(Sender: TObject);
begin
  if FreebiePointsPanel.Enabled then
    FreebiePointsUndoStack.PopAndUndo
  else
    begin
      with PCMain do
        if Assigned(ActivePage) then
          TUndoStack(ActivePage.Tag).PopAndUndo;

      CheckIfReadyForFreebies;
    end;
end;

procedure TMainForm.MMClearPageClick(Sender: TObject);
begin
  if FreebiePointsPanel.Enabled then
    MessageDlg('Only File | New can clear a page when Freebies are enabled.',
               mtInformation,[mbOk],0)
  else
    with PCMain do
      if Assigned(ActivePage) then
        with ActivePage do
          if Name = 'TSFinal' then
            MessageDlg('Only File | New can clear Final page.',
                       mtInformation,[mbOk],0)
          else if MessageDlg('Really clear ' + Copy(Name,3,255) + ' page?',
                             mtConfirmation,mbYesNoCancel,0) = mrYes then
            ClearPage(ActivePage,False);
end;

procedure TMainForm.CBClanChange(Sender: TObject);
(* Note - anytime you set or change the value of CBClan.ItemIndex in code,
   you must call this method manually (in code). *)
begin
  { Not using Sender, as this method may be called in several ways. }
  with CBClan do
    if Text <> PreviousClan then
      begin
        (* Caitiffs can select any Discipline, so we enable everything.
           Other Clans can select only Clan Disciplines, so we disable
           everything now and enable Clan Disciplines below.
         *)
        SetEnabledOnAllDisciplines(Text = 'Caitiff');

        { Note that this will reveal the "UGLY!" label for Nosferatu. }
        DEAppearance.Visible := (Text <> 'Nosferatu');

        if Text = 'Brujah' then
          begin
            DECelerity.Enabled := True;
            DEPotence.Enabled  := True;
            DEPresence.Enabled := True;
          end
        else if Text = 'Gangrel' then
          begin
            DEAnimalism.Enabled := True;
            DEFortitude.Enabled := True;
            DEProtean.Enabled   := True;
          end
        else if Text = 'Malkavian' then
          begin
            DEAuspex.Enabled    := True;
            DEDominate.Enabled  := True;
            DEObfuscate.Enabled := True;
          end
        else if Text = 'Nosferatu' then
          begin
            DEAnimalism.Enabled := True;
            DEObfuscate.Enabled := True;
            DEPotence.Enabled   := True;
          end
        else if Text = 'Toreador' then
          begin
            DEAuspex.Enabled   := True;
            DECelerity.Enabled := True;
            DEPresence.Enabled := True;
          end
        else if Text = 'Tremere' then
          begin
            DEAuspex.Enabled      := True;
            DEDominate.Enabled    := True;
            DEThaumaturgy.Enabled := True;
          end
        else if Text = 'Ventrue' then
          begin
            DEDominate.Enabled  := True;
            DEFortitude.Enabled := True;
            DEPresence.Enabled  := True;
          end;
        { For Caitiffs, we're done. }

        PreviousClan := Text;
      end;
end;

procedure TMainForm.PCMainChange(Sender: TObject);
begin
  (* NOTE - if TPageControl.ActivePage is set or TTabSheet.Show is called
     in code, this method will NOT be called automatically.
   *)
  if PCMain.ActivePage.Name = 'TSFinal' then
    begin
      { switching TO Final page }
      DEHumanity.Dots  := DEHumanity.Dots +
                          (DEConscience.Dots + DESelfControl.Dots);

      DEWillpower.Dots := DEWillpower.Dots + DECourage.Dots;
    end;
end;

procedure TMainForm.BEnableFreebiesClick(Sender: TObject);
begin
  if MessageDlg('Enabling Freebies is not undoable - proceed?',
                mtConfirmation,mbYesNoCancel,0) = mrYes then
    begin
      { Panel's Enabled state is used elsewhere to check if Freebies enabled }
      FreebiePointsPanel.Enabled := True;

      DEHumanity.Enabled  := True;
      DEWillpower.Enabled := True;

      SetEnabledOnAllDisciplines(True);

      { This Undo Stack is clear, and there's no need to clear others. }

      DEHumanity.SetFocus;

      BEnableFreebies.Enabled := False;
    end;
end;

procedure TMainForm.PCMainChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  (* NOTE - if TPageControl.ActivePage is set or TTabSheet.Show is called
     in code, this method will NOT be called automatically.
   *)
  if PCMain.ActivePage.Name = 'TSFinal' then
    begin
      { switching FROM Final page }
      DEHumanity.Dots  := DEHumanity.Dots -
                          (DEConscience.Dots + DESelfControl.Dots);

      DEWillpower.Dots := DEWillpower.Dots - DECourage.Dots;
      { Humanity and Willpower will not be correct unless the page is Final }
    end;
end;

procedure TMainForm.MMPrintClick(Sender: TObject);
var
  RealHumanity  : Byte;
  RealWillpower : Byte;
begin
  { If Freebies = 0, all points have been allocated. }
  if Assigned(PCMain.ActivePage) and
     ((StrToIntDef(FreebiePointsPanel.Caption,0) = 0) or
      (MessageDlg('Not all points have been allocated - print anyway?',
                  mtConfirmation,mbYesNoCancel,0) = mrYes)) and
     PrintDialog.Execute then
    begin
      RealHumanity  := DEHumanity.Dots;
      RealWillpower := DEWillpower.Dots;

      if PCMain.ActivePage.Name <> 'TSFinal' then
        begin
          Inc(RealHumanity,(DEConscience.Dots + DESelfControl.Dots));
          Inc(RealWillpower,DECourage.Dots);
        end;

      PrintCharacter(RealHumanity,RealWillpower);

      MessageDlg('Initial Blood Pool is ' + IntToStr(DEBloodPool.Dots) +
                 ' - please pencil in.',mtInformation,[mbOk],0);
    end;
end;

procedure TMainForm.MMPrintSetupClick(Sender: TObject);
begin
  PrinterSetupDialog.Execute;
end;

procedure TMainForm.MMAboutClick(Sender: TObject);
begin
  AboutBox := TAboutBox.Create(Application);
  
  try
    AboutBox.ShowModal;
  finally
    AboutBox.Free;
  end;
end;

procedure TMainForm.PrintCharacter(RealHumanity: Byte; RealWillpower: Byte);
{ assumes PrintDialog already called }
{ Yes, this could be cleaned up a lot.  But it works. }
const
  MARGIN_LEFT_INCHES    = 0.75;
  COL2_LEFT_INCHES      = 3.1875;
  COL3_LEFT_INCHES      = 5.625;
  DOTS_OFFSET_INCHES    = 1.5;
  LINE_OFFSET_INCHES    = 0.1875;
  GB_VERT_OFFSET_INCHES = 0.3125;  { group box caption offset from section top }

  CHAR_EMPTYDOT         = Chr(161);  { Wingding for empty circle }
  CHAR_EMPTYSQUARE      = Chr(168);  { Wingding for empty square }

var
  { PrtPixel vars are read by local functions, too - init. before calling }
  PrtPixelsPerInchX : Integer;
  PrtPixelsPerInchY : Integer;
  PrtPixelOffsetX   : Integer;
  PrtPixelOffsetY   : Integer;
  PrtPixelMaxX      : Integer;
  PrtPixelMaxY      : Integer;
  PrtPixelColWidth  : Integer;  { Column width }

  CurrentPixelLine  : Integer;
  SectionTopInches  : Double;

  OutputString      : String;
  i                 : Integer;
  TempDotEdit       : TDotEdit;

  { The In2Pix functions convert inches to printer pixel OFFSETS. }
  { Do NOT use these for calculating column widths, line heights, etc. }
  function XIn2Pix(Inches: Double) : Integer;
  begin
    Result := Round(PrtPixelsPerInchX * Inches) - PrtPixelOffsetX;

    if Result < 0 then
      Result := 0
    else if Result > PrtPixelMaxX then
      Result := PrtPixelMaxX;
  end;

  function YIn2Pix(Inches: Double) : Integer;
  { assumes PrtPixel vars initialized }
  begin
    Result := Round(PrtPixelsPerInchY * Inches) - PrtPixelOffsetY;

    if Result < 0 then
      Result := 0
    else if Result > PrtPixelMaxY then
      Result := PrtPixelMaxY;
  end;

  procedure PrintCentered(InchesTop: Double; TextToPrint: String);
  { assumes BeginDoc already called }
  { uses current printer canvas font }
  begin
    with Printer.Canvas do
      TextOut((PrtPixelMaxX + 1 - TextWidth(TextToPrint)) div 2,
              YIn2Pix(InchesTop),TextToPrint);
    { Offset should be on both sides, cancelling out }
  end;

  procedure PrintSectionHeader(InchesTop: Double; HeaderText: String);
  { assumes BeginDoc already called }
  { preserves current printer canvas font and pen }
  { not very generic - could be improved }
  var
    OldPrinterFont : TFont;
    OldPen         : TPen;
  begin
    OldPrinterFont := TFont.Create;
    OldPrinterFont.Assign(Printer.Canvas.Font);

    OldPen := TPen.Create;
    OldPen.Assign(Printer.Canvas.Pen);

    try
      with Printer.Canvas do
        begin
          with Font do
            begin
              Name  := 'Times New Roman';
              Size  := 16;
              Style := [fsBold];
            end;

            PrintCentered(InchesTop,HeaderText);

            Pen.Width := 8;

            { Note that Font.Height will be negative. }

            MoveTo(XIn2Pix(MARGIN_LEFT_INCHES),
                   YIn2Pix(InchesTop) + 4 - (Font.Height div 2));

            { It's a little bit cheesy but it's nicely displayed. }

            LineTo(XIn2Pix(MARGIN_LEFT_INCHES + 2.75),PenPos.Y);

            MoveTo(XIn2Pix(5),PenPos.Y);
            LineTo(XIn2Pix(7.75),PenPos.Y);
        end;
    finally
      Printer.Canvas.Pen.Assign(OldPen);
      OldPen.Free;

      Printer.Canvas.Font.Assign(OldPrinterFont);
      OldPrinterFont.Free;
    end;
  end;

  procedure PrintGroupBox(InchesLeft: Double; InchesTop: Double;
                          WhichGroupBox: TGroupBox);
  { assumes BeginDoc already called }
  { preserves current printer canvas font }
  { WARNING - do NOT call with GBFinishingTouches!!!! }
  var
    OldPrinterFont   : TFont;
    TraitAlphaList   : TStringList;
    TraitCaption     : String;
    i                : Integer;
  begin
    OldPrinterFont := TFont.Create;
    OldPrinterFont.Assign(Printer.Canvas.Font);

    TraitAlphaList := TStringList.Create;

    try
      with Printer.Canvas do
        begin
          with Font do
            begin
              Name  := 'Times New Roman';
              Size  := 14;
              Style := [fsBold];
            end;

          { center the caption in the column }

          TextOut(XIn2Pix(InchesLeft) +
                  ((PrtPixelColWidth + 1 - TextWidth(WhichGroupBox.Caption))
                   div 2),
                  YIn2Pix(InchesTop),WhichGroupBox.Caption);
        end;

      InchesTop := InchesTop + (LINE_OFFSET_INCHES * 1.5);

      with WhichGroupBox do
        begin
          if Name = 'GBPhysical' then
            with TraitAlphaList do
              begin
                Add('Strength');
                Add('Dexterity');
                Add('Stamina');
                { in that order }
              end
          else if Name = 'GBSocial' then
            with TraitAlphaList do
              begin
                Add('Charisma');
                Add('Manipulation');
                Add('Appearance');
              end
          else if Name = 'GBMental' then
            with TraitAlphaList do
              begin
                Add('Perception');
                Add('Intelligence');
                Add('Wits');
              end
          else if Name = 'GBVirtues' then
            with TraitAlphaList do
              begin
                Add('Conscience');
                Add('SelfControl');
                Add('Courage');
              end
          else
            begin
              for i := 0 to (ControlCount - 1) do
                if Controls[i] is TDotEdit then
                  TraitAlphaList.Add(Copy(Controls[i].Name,3,255));

              TraitAlphaList.Sort;  { alphabetical order }
            end;
        end;

      for i := 0 to (TraitAlphaList.Count - 1) do
        begin
          with Printer.Canvas do
            begin
              with Font do
                begin
                  Name  := 'Times New Roman';
                  Size  := 10;
                  Style := [];
                end;

              { using label caption sans colon to get spaces, dashes, etc. }
              with FindComponent('L' + TraitAlphaList[i]) as TLabel do
                TraitCaption := Copy(Caption,1,Length(Caption) - 1);

              TextOut(XIn2Pix(InchesLeft),YIn2Pix(InchesTop),TraitCaption);

              { Note that Font.Height will be negative. }

              MoveTo(XIn2Pix(InchesLeft) + TextWidth(TraitCaption),
                     YIn2Pix(InchesTop) - Font.Height);

              LineTo(XIn2Pix(InchesLeft + DOTS_OFFSET_INCHES),PenPos.Y);
            end;  { ending this With here to avoid confusion }

          if (TraitAlphaList[i] = 'Appearance') and
             (CBClan.Text = 'Nosferatu') then
            begin
              Printer.Canvas.Font.Assign(LUgly.Font);

              Printer.Canvas.TextOut(XIn2Pix(InchesLeft + DOTS_OFFSET_INCHES),
                                     YIn2Pix(InchesTop),LUgly.Caption);
            end
          else
            with FindComponent('DE' + TraitAlphaList[i]) as TDotEdit do
              begin
                Printer.Canvas.Font.Assign(Font);

                Printer.Canvas.TextOut(XIn2Pix(InchesLeft + DOTS_OFFSET_INCHES),
                                       YIn2Pix(InchesTop),Text);
              end;

          InchesTop := InchesTop + LINE_OFFSET_INCHES;

          if WhichGroupBox.Name = 'GBVirtues' then
            InchesTop := InchesTop + LINE_OFFSET_INCHES;  { extra spacing }
        end;

    finally
      TraitAlphaList.Free;

      Printer.Canvas.Font.Assign(OldPrinterFont);
      OldPrinterFont.Free;
    end;
  end;

  procedure PrintLineBreak(InchesTop: Double);
  { assumes BeginDoc already called }
  { preserves current printer canvas pen }
  var
    OldPen : TPen;
  begin
    OldPen := TPen.Create;
    OldPen.Assign(Printer.Canvas.Pen);

    try
      with Printer.Canvas do
        begin
            Pen.Width := 8;
            MoveTo(XIn2Pix(MARGIN_LEFT_INCHES),YIn2Pix(InchesTop));
            LineTo(XIn2Pix(8.5 - MARGIN_LEFT_INCHES),PenPos.Y);
        end;
    finally
      Printer.Canvas.Pen.Assign(OldPen);
      OldPen.Free;
    end;
  end;

begin  { procedure PrintCharacter }
  with Printer do
    begin
      Title       := 'Embracer Character';
      Orientation := poPortrait;  { force this }

      BeginDoc;

      PrtPixelsPerInchX := GetDeviceCaps(Handle,LOGPIXELSX);
      PrtPixelsPerInchY := GetDeviceCaps(Handle,LOGPIXELSY);
      PrtPixelOffsetX   := GetDeviceCaps(Handle,PHYSICALOFFSETX);
      PrtPixelOffsetY   := GetDeviceCaps(Handle,PHYSICALOFFSETY);
      PrtPixelMaxX      := PageWidth;
      PrtPixelMaxY      := PageHeight;

      try
        with Canvas do
          begin
            { calculate column width - any DotEdit would work }
            Font.Assign(DEStrength.Font);

            { not calling XIn2Pix, as we don't want offset included }
            PrtPixelColWidth :=
              Round(PrtPixelsPerInchX * DOTS_OFFSET_INCHES) +
                    TextWidth(DEStrength.Text);

            with Font do
              begin
                Name  := 'Times New Roman';
                Size  := 36;
                Style := [fsBold];
              end;

            PrintCentered(0.25,'VAMPIRE');

            Font.Size := 10;

            CurrentPixelLine := YIn2Pix(0.875);

            Font.Style := [fsBold];
            TextOut(XIn2Pix(MARGIN_LEFT_INCHES),CurrentPixelLine,'Name:  ');
            Font.Style := [];
            TextOut(PenPos.X,CurrentPixelLine,EName.Text);

            Font.Style := [fsBold];
            TextOut(XIn2Pix(COL2_LEFT_INCHES),CurrentPixelLine,'Nature:  ');
            Font.Style := [];
            TextOut(PenPos.X,CurrentPixelLine,CBNature.Text);

            Font.Style := [fsBold];
            TextOut(XIn2Pix(COL3_LEFT_INCHES),CurrentPixelLine,'Generation:  ');
            Font.Style := [];
            TextOut(PenPos.X,CurrentPixelLine,
                    IntToStr(13 - DEGeneration.Dots) + 'th');

            { not adjusting Blood Pool for Generation in this version }

            { not calling YIn2Pix, as offset's already included }
            Inc(CurrentPixelLine,Round(PrtPixelsPerInchY * LINE_OFFSET_INCHES));

            Font.Style := [fsBold];
            TextOut(XIn2Pix(MARGIN_LEFT_INCHES),CurrentPixelLine,'Player:  ');
            Font.Style := [];
            TextOut(PenPos.X,CurrentPixelLine,EPlayer.Text);

            Font.Style := [fsBold];
            TextOut(XIn2Pix(COL2_LEFT_INCHES),CurrentPixelLine,'Demeanor:  ');
            Font.Style := [];
            TextOut(PenPos.X,CurrentPixelLine,CBDemeanor.Text);

            Font.Style := [fsBold];
            TextOut(XIn2Pix(COL3_LEFT_INCHES),CurrentPixelLine,'Haven:');

            Inc(CurrentPixelLine,Round(PrtPixelsPerInchY * LINE_OFFSET_INCHES));

            Font.Style := [fsBold];
            TextOut(XIn2Pix(MARGIN_LEFT_INCHES),CurrentPixelLine,'Chronicle:');

            Font.Style := [fsBold];
            TextOut(XIn2Pix(COL2_LEFT_INCHES),CurrentPixelLine,'Clan:  ');
            Font.Style := [];
            TextOut(PenPos.X,CurrentPixelLine,CBClan.Text);

            Font.Style := [fsBold];
            TextOut(XIn2Pix(COL3_LEFT_INCHES),CurrentPixelLine,'Concept:  ');
            Font.Style := [];
            TextOut(PenPos.X,CurrentPixelLine,CBConcept.Text);

            SectionTopInches := 1.5625;
            PrintSectionHeader(SectionTopInches,'Attributes');
            SectionTopInches := SectionTopInches + GB_VERT_OFFSET_INCHES;

            PrintGroupBox(MARGIN_LEFT_INCHES, SectionTopInches, GBPhysical);
            PrintGroupBox(COL2_LEFT_INCHES,   SectionTopInches, GBSocial);
            PrintGroupBox(COL3_LEFT_INCHES,   SectionTopInches, GBMental);

            SectionTopInches := 2.875;
            PrintSectionHeader(SectionTopInches,'Abilities');
            SectionTopInches := SectionTopInches + GB_VERT_OFFSET_INCHES;

            PrintGroupBox(MARGIN_LEFT_INCHES, SectionTopInches, GBTalents);
            PrintGroupBox(COL2_LEFT_INCHES,   SectionTopInches, GBSkills);
            PrintGroupBox(COL3_LEFT_INCHES,   SectionTopInches, GBKnowledge);

            SectionTopInches := 5.5;
            PrintSectionHeader(SectionTopInches,'Advantages');
            SectionTopInches := SectionTopInches + GB_VERT_OFFSET_INCHES;

            PrintGroupBox(MARGIN_LEFT_INCHES, SectionTopInches, GBDisciplines);
            PrintGroupBox(COL2_LEFT_INCHES,   SectionTopInches, GBBackgrounds);
            PrintGroupBox(COL3_LEFT_INCHES,   SectionTopInches, GBVirtues);

            SectionTopInches := 8.25;
            PrintLineBreak(SectionTopInches);

            with Font do
              begin
                Name  := 'Times New Roman';
                Size  := 14;
                Style := [fsBold];
              end;

            { center "Combat" in our skinny column }

            TextOut(XIn2Pix(MARGIN_LEFT_INCHES) +
                    ((Round(PrtPixelsPerInchX * 1.75) + 1 - TextWidth('Combat'))
                     div 2),
                    YIn2Pix(SectionTopInches + LINE_OFFSET_INCHES),
                    'Combat');

            Rectangle(XIn2Pix(MARGIN_LEFT_INCHES),
                      YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 2.5)),
                      XIn2Pix(MARGIN_LEFT_INCHES + 1.75),
                      YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 8)));

            Font.Size  := 8;
            Font.Style := [];

            TextOut(XIn2Pix(MARGIN_LEFT_INCHES + 0.0625),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 3)),
                    'Weapon');

            TextOut(XIn2Pix(MARGIN_LEFT_INCHES + 1.0625),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 3)),
                    'Diff.');

            TextOut(XIn2Pix(MARGIN_LEFT_INCHES + 1.4375),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 3)),
                    'Dam.');

            MoveTo(XIn2Pix(MARGIN_LEFT_INCHES + 1),
                   YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 2.5)));

            LineTo(PenPos.X,
                   YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 8)));

            MoveTo(XIn2Pix(MARGIN_LEFT_INCHES + 1.375),
                   YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 2.5)));

            LineTo(PenPos.X,
                   YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 8)));

            for i := 4 to 7 do
              begin
                MoveTo(XIn2Pix(MARGIN_LEFT_INCHES),
                       YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * i)));

                LineTo(XIn2Pix(MARGIN_LEFT_INCHES + 1.75),PenPos.Y);
              end;

            with Font do
              begin
                Name  := 'Times New Roman';
                Size  := 14;
                Style := [fsBold];
              end;

            PrintCentered(SectionTopInches + LINE_OFFSET_INCHES,'Humanity');

            Font.Size  := 10;
            Font.Style := [fsItalic];

            PrintCentered(SectionTopInches + (LINE_OFFSET_INCHES * 2),
                          '(Initial:  ' + IntToStr(RealHumanity) + ')');

            Font.Assign(DEHumanity.Font);  { any DotEdit would work }
            Font.Size := 12;

            OutputString := '';

            for i := 1 to DEHumanity.MaxDots do
              OutputString := OutputString + CHAR_EMPTYDOT + ' ';

            Delete(OutputString,Length(OutputString),1);  { remove last space }

            PrintCentered(SectionTopInches + (LINE_OFFSET_INCHES * 3),
                          OutputString);

            with Font do
              begin
                Name  := 'Times New Roman';
                Size  := 14;
                Style := [fsBold];
              end;

            PrintCentered(SectionTopInches + (LINE_OFFSET_INCHES * 4.5),
                          'Willpower');

            Font.Assign(DEWillpower.Font);  { any DotEdit would work }
            Font.Size := 12;

            { create a temporary DotEdit to get those weird characters }
            TempDotEdit := TDotEdit.Create(Self);

            try
              with TempDotEdit do
                begin
                  MaxDots := DEWillpower.MaxDots;
                  Dots    := RealWillpower;

                  OutputString := '';

                  { insert a space after each character }
                  for i := 1 to DEWillpower.MaxDots do
                    OutputString := OutputString + Copy(Text,i,1) + ' ';

                  { remove last space }
                  Delete(OutputString,Length(OutputString),1);
                end;
            finally
              TempDotEdit.Free;
              { Delphi auto-removes the comp. from the form's Component array. }
            end;

            PrintCentered(SectionTopInches + (LINE_OFFSET_INCHES * 6),
                          OutputString);

            OutputString := '';

            for i := 1 to DEWillpower.MaxDots do
              OutputString := OutputString + CHAR_EMPTYSQUARE + ' ';

            Delete(OutputString,Length(OutputString),1);  { remove last space }

            PrintCentered(SectionTopInches + (LINE_OFFSET_INCHES * 7),
                          OutputString);

            with Font do
              begin
                Name  := 'Times New Roman';
                Size  := 14;
                Style := [fsBold];
              end;

            PrintCentered(SectionTopInches + (LINE_OFFSET_INCHES * 8.5),
                          'Blood Pool');

            Font.Assign(DEBloodPool.Font);  { any DotEdit would work }
            Font.Size := 12;

            { Print empty boxes for Blood Pool - user is asked to pencil in. }

            OutputString := '';

            for i := 1 to DEBloodPool.MaxDots do
              OutputString := OutputString + CHAR_EMPTYSQUARE + ' ';

            Delete(OutputString,Length(OutputString),1);  { remove last space }

            PrintCentered(SectionTopInches + (LINE_OFFSET_INCHES * 10),
                          OutputString);

            with Font do
              begin
                Name  := 'Times New Roman';
                Size  := 14;
                Style := [fsBold];
              end;

            TextOut(XIn2Pix(6.625),
                    YIn2Pix(SectionTopInches + LINE_OFFSET_INCHES),
                    'Health');

            Font.Size  := 12;
            Font.Style := [];

            TextOut(XIn2Pix(6.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 2.5)),
                    'Bruised');

            TextOut(XIn2Pix(6.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 3.5)),
                    'Hurt');

            TextOut(XIn2Pix(7.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 3.5)),
                    '-1');

            TextOut(XIn2Pix(6.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 4.5)),
                    'Injured');

            TextOut(XIn2Pix(7.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 4.5)),
                    '-1');

            TextOut(XIn2Pix(6.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 5.5)),
                    'Wounded');

            TextOut(XIn2Pix(7.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 5.5)),
                    '-2');

            TextOut(XIn2Pix(6.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 6.5)),
                    'Mauled');

            TextOut(XIn2Pix(7.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 6.5)),
                    '-2');

            TextOut(XIn2Pix(6.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 7.5)),
                    'Crippled');

            TextOut(XIn2Pix(7.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 7.5)),
                    '-5');

            TextOut(XIn2Pix(6.25),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 8.5)),
                    'Incapacitated');

            Font.Assign(DEStrength.Font);  { any DotEdit would work }
            Font.Size := 12;

            for i := 2 to 8 do
              TextOut(XIn2Pix(7.5),
                      YIn2Pix(SectionTopInches +
                              (LINE_OFFSET_INCHES * (i + 0.5))),
                      CHAR_EMPTYSQUARE);

            with Font do
              begin
                Name  := 'Times New Roman';
                Size  := 14;
                Style := [fsBold];
              end;

            TextOut(XIn2Pix(6.125),
                    YIn2Pix(SectionTopInches + (LINE_OFFSET_INCHES * 10)),
                    'Experience:');
          end;
      finally
        EndDoc;  { Abort seems to cause instability }
      end;
    end;
end;

end.
